void analysis(double energy_low, double energy_high)
{
	struct data_t
	{
		double energy1;
		double theta1;
		double phi1;
		double energy2;
		double theta2;
		double phi2;
		double x0;
		double y0;
		double z0;
		double distance;
		double energy1Rec;
		double theta1Rec;
		double phi1Rec;
		double energy2Rec;
		double theta2Rec;
		double phi2Rec;
		double x0Rec;
		double y0Rec;
		double z0Rec;
		bool detection1;
		bool detection2;
	};
	data_t data;
	TFile *filei = new TFile(("/Users/acorsi/codes/MINOS_simulation/Analysis/result/test.root"), "READ");	
	TTree *treei = (TTree *)filei->Get("TREE_RESOL");
	treei->SetBranchAddress("RESOL", &data);
	
	TCanvas *c = new TCanvas("C","",400,400);
	TH1D *h = new TH1D("h","Energy Reconstruction",1000,-1000,1000);
	TH1D *h1 = new TH1D("h1","",1000,-1000,1000);
	TH1D *h1Rec = new TH1D("h1Rec","",1000,-1000,1000);
	TH1D *h2 = new TH1D("h2","",1000,-1000,1000);
	TH1D *h2Rec = new TH1D("h2Rec","",1000,-1000,1000);
	TGraph *g1 = new TGraph();
	TGraph *g2 = new TGraph();
	Int_t nevent = treei->GetEntries();	
	for(Int_t i=0; i<nevent; i++)
	{
		treei->GetEvent(i);
		if(data.energy1 > energy_low && data.energy1 < energy_high && data.detection1==true) {h->Fill(data.energy1Rec-data.energy1); h1->Fill(data.energy1); h1Rec->Fill(data.energy1Rec);}
		if(data.energy2 > energy_low && data.energy2 < energy_high && data.detection2==true) {h->Fill(data.energy2Rec-data.energy2); h2->Fill(data.energy2); h2Rec->Fill(data.energy2Rec);}
		if(data.detection1==true) g1->SetPoint(i,data.energy1,data.energy1Rec);
		if(data.detection2==true) g2->SetPoint(i,data.energy2,data.energy2Rec);
	}
	g1->SetMarkerStyle(1);
	g1->Draw("ap");
	g2->SetMarkerStyle(1);
	g2->SetMarkerColor(2);
	g2->Draw("p");
	TCanvas *c2= new TCanvas("C2","",400,400);
	h->DrawCopy();
	TCanvas *c3= new TCanvas("C3","",400,400);
	h1->DrawCopy();
	h1Rec->SetLineStyle(2);
	h1Rec->DrawCopy("same");
	h2->SetLineColor(2);
	h2->DrawCopy("same");
	h2Rec->SetLineStyle(2);
	h2Rec->SetLineColor(2);
	h2Rec->DrawCopy("same");
}
